#include <stdio.h>
#include "compressor.h"

int parse(int argc, char *argv[], Ttree tree, struct node *pointers[],
  int *n) {
    if (argc < 4) {
        printf("mmwoo..\nusage: \"foo [option] [file1] [file2]\"\n"
               "\toptions:\n\tc\tcompress \"file1\" to \"file2\"\n\t"
               "d\tdecompress \"file1\" to \"file2\"\n");
        return 1;
    }
    else {
        if (!freopen(argv[2], "r", stdin)) 
        {
            perror("freopen");
            return 1;
        }

        if(*argv[1] == 'c') {
            prep2comp(tree, pointers, n);
            if (!freopen(argv[3], "w", stdout)) {
                perror("freopen");
                return 1;
            }
            if (!freopen(argv[2], "r", stdin)) {
                perror("freopen");
                return 1;
            }
            if (*n == 0) return 0;
            compress(tree, pointers, &tree[*n - 1]);
        }
        else if (*argv[1] == 'd') {
            prep2decomp(tree, n);
            if (!freopen(argv[3], "w", stdout)) {
                perror("freopen");
                return 1;
            }
            if (tree[*n].number == 0) return 0;
            decompress(tree, *n);
        }
        else {
            printf("unavailable option\n");
            return 1;
        }
    }

    return 0;
}
